theory Schreiner_Examples 
imports Main 
begin

section {* Examples investigated by Wolfgang Schreiner *}

subsection {* Example L1 *}

subsection {* Exercise 4.1 *}

lemma exercise_4_1:
  "\<forall> (x::'a) (y::'a) (T :: 'a \<Rightarrow> 'a \<Rightarrow> bool) (A :: 'a \<Rightarrow> 'a \<Rightarrow> bool) .
    (\<forall> x y. T x y \<or> T y x) \<and>
    (\<forall> x y. A x y \<or> A y x \<longrightarrow> x = y) \<and>
    (\<forall> x y. T x y \<longrightarrow> A x y) \<and>
    A x y \<longrightarrow> T x y"
proof -
  {
    fix x y :: 'a
    fix A T :: "'a \<Rightarrow> 'a \<Rightarrow> bool"
    assume T: "\<forall> x y. T x y \<or> T y x"
    assume A: "\<forall> x y. A x y \<or> A y x \<longrightarrow> x = y"
    assume TA: "\<forall> x y. T x y \<longrightarrow> A x y"
    assume A0: "T x y"
    have "T x y"
    proof (rule ccontr)
      assume C: "\<not>T x y"
      moreover from this T have "T y x" by auto
      moreover from this TA have "A y x" by auto
      moreover from this A A0 have "x = y" by auto
      ultimately show "False" by auto
    qed
  }
  from this show ?thesis 
apply auto sorry
oops (*qed       ? ? ? ? ?*)

lemma exercise_4_1a:
  fixes x y :: 'a
  fixes A T :: "'a \<Rightarrow> 'a \<Rightarrow> bool"
  assumes "\<forall> x y. T x y \<or> T y x"
  assumes "\<forall> x y. A x y \<or> A y x \<longrightarrow> x = y"
  assumes "\<forall> x y. T x y \<longrightarrow> A x y"
  assumes "T x y"
  shows "T x y"
  proof (rule ccontr)
    assume C: "\<not>T x y"
    moreover from this assms have "T y x" by auto
    moreover from this assms have "A y x" by auto
    moreover from this assms have "x = y" by auto
    ultimately show "False" by auto
qed

lemma evenOrOdd:
  fixes n::"nat"
  shows "\<exists>m::nat. n = 2*m \<or> n = 2*m + 1"
proof - 
  show ?thesis by arith
qed

lemma Exercise_4_2:
  fixes xs :: "'a list"
  shows "(\<exists> ys zs . xs = ys @ zs \<and> length ys = length zs) \<or>
         (\<exists> ys zs . xs = ys @ zs \<and> length ys = length zs + 1)"
proof (cases "\<exists> n::nat . length xs = 2*n")
  case "True"
  from this obtain n where L: "length xs = 2*n" by auto
  let ?ys = "take n xs"
  let ?zs = "drop n xs"
  from L have "xs = ?ys @ ?zs \<and> length ?ys = length ?zs" by auto
  from this show ?thesis by blast
next
  case "False"
  from this evenOrOdd have "\<exists> n::nat . length xs = 2*n + 1" by blast
  from this obtain n where L: "length xs = 2*n + 1" by auto
  let ?ys = "take (n+1) xs"
  let ?zs = "drop (n+1) xs"
  from L have "xs = ?ys @ ?zs \<and> length ?ys = length ?zs + 1" by auto
  from this show ?thesis by blast
qed

lemma Logic1:
  fixes P :: "'a => 'a => bool"
  assumes "\<exists> x. (\<forall> y. P x y)"
  shows "\<forall> y. (\<exists> x. P x y)"
proof 
  fix y
  from assms obtain x where "P x y" by auto
  from this show "\<exists> x. P x y" by auto
qed

lemma Logic2:
  fixes P :: "'a => bool"
  fixes Q :: "'a => 'a => bool"
  assumes "\<exists>x. P x"
  assumes "\<forall>x. P x \<longrightarrow> (\<exists>y. Q x y)"
  shows   "\<exists>x y. Q x y"
proof -
  from assms obtain x where "P x" by auto
  from this assms have "\<exists>y. Q x y" by auto
  from this obtain y where "Q x y" by auto
  from this show ?thesis by auto
qed

lemma Logic2a:
  fixes P :: "'a => bool"
  fixes Q :: "'a => 'a => bool"
  assumes "\<exists>x. P x"
  assumes "\<forall>x. P x \<longrightarrow> (\<exists>y. Q x y)"
  shows   "\<exists>x y. Q x y" (is "?F")
proof (rule ccontr)
  assume "\<not>?F"
  moreover from this obtain y where "\<forall>x. \<not>Q x y" by auto
  moreover from assms obtain x where "P x" by auto
  moreover from this assms have "\<exists>y. Q x y" by auto
  ultimately show "False" by auto
qed

end
