theory Isa_For_Math_0
imports Main "~~/src/Tools/Apply_Trace/Apply_Trace_Cmd"
  (*see David Greenaway http://stackoverflow.com/a/26827242/570879 *)
begin

text \<open>Notes on the learning scenario's state:
  # we want to implement proofs from "WS-Logic-and-proving" and 
  "WS-WW-First-order-predicate-logic" and get stuck at the beginnen.
  ## DONE clarify tracing facilities for auto
  ## TODO clarify "proof -" | "proof (rule" | ...
  ## TODO clarify "apply (rule" instead of "apply auto"
  ## 

  # we study other introductions to Isabelle for appropriate proofs and exercises
  ## DONE prog-prove p.41 -- end
      4 Isar: A Language for Structured Proofs
      4.1 Isar by Example:          1 example "surj f" in variants
      4.2 Proof Patterns !
      4.3 Streamlining Proofs       p.49 example dvd
  ## TODO isar-ref
  ## TODO Makarius Wenzel, Some aspects of Isabelle/Isar, May 2011
  ## 

  # we stop this scenario when 10 proofs are ready and
  fetch feedback from Wolfgang Schreiner.
\<close>

section \<open>Attempts to watch automated provers\<close>

(* we would like to watch "auto": but "auto" doesnt invoke "simp" here *)
lemma "(\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)"
using [[simp_trace_new mode=full]]
using [[simp_break "_ \<longrightarrow> _"]]
by auto

(* attempt 2 to watch *)
lemma "(\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)"
using [[simp_trace_new mode=full]]
by metis
(*Simplifier invoked 
  \<not> ATP.fTrue \<Longrightarrow> False 
    Apply rewrite rule? 
      Instance of ??.unknown: ATP.fTrue \<equiv> True
      Trying to rewrite: ATP.fTrue 
        Successfully rewrote 
          ATP.fTrue \<equiv> True 
Simplifier invoked 
  ATP.fFalse \<Longrightarrow> False 
    Apply rewrite rule? 
      Instance of ??.unknown: ATP.fFalse \<equiv> False
      Trying to rewrite: ATP.fFalse 
        Successfully rewrote 
          ATP.fFalse \<equiv> False 
Simplifier invoked 
  \<not> P x__ y__ \<Longrightarrow> False 
    Apply rewrite rule? 
      Instance of Metis.not_atomize: (\<not> P x__ y__ \<Longrightarrow> False) \<equiv> P x__ y__
      Trying to rewrite: \<not> P x__ y__ \<Longrightarrow> False 
        Successfully rewrote 
          (\<not> P x__ y__ \<Longrightarrow> False) \<equiv> P x__ y__*)

(*thm "ATP.fTrue"       --{* Undefined fact: "ATP.fTrue"\<here> *}
thm "fTrue"
thm "ATP.fFalse"
thm "fFalse"                                              *)
thm "Metis.not_atomize" --{* (\<not> ?A \<Longrightarrow> False) \<equiv> ?A *}

(* attempt 3 to watch *)
lemma "(\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)"
  using [[simp_trace]]
by metis
(*lemma (\<exists>x. \<forall>y. ?P x y) \<longrightarrow> (\<forall>y. \<exists>x. ?P x y) 
[0]Adding rewrite rule "HOL.simp_implies_def":
op =simp=> \<equiv> op \<Longrightarrow> 
[0]Adding rewrite rule "HOL.Ex1_def":
Ex1 ?P \<equiv> \<exists>x. ?P x \<and> (\<forall>y. ?P y \<longrightarrow> y = x) 
[0]Adding rewrite rule "??.unknown":
Ball ?A1 ?P1 \<equiv> \<forall>x. x \<in> ?A1 \<longrightarrow> ?P1 x 
[0]Adding rewrite rule "??.unknown":
Bex ?A1 ?P1 \<equiv> \<exists>x. x \<in> ?A1 \<and> ?P1 x 
[0]Adding rewrite rule "??.unknown":
if True then ?y else ?y1 \<equiv> ?y 
[0]Adding rewrite rule "??.unknown":
if False then ?x1 else ?y \<equiv> ?y 
[0]Adding rewrite rule "??.unknown":
if ?c1 then ?y else ?y \<equiv> ?y 
[0]Adding rewrite rule "??.unknown":
if ?y = ?y1 then ?y1 else ?y \<equiv> ?y 
[0]Adding rewrite rule "??.unknown":
(?P1 \<longrightarrow> ?y) \<and> (\<not> ?P1 \<longrightarrow> ?y) \<equiv> ?y 
[0]Adding rewrite rule "??.unknown":
Let \<equiv> \<lambda>s f. f s 
[1]SIMPLIFIER INVOKED ON THE FOLLOWING TERM:
\<not> ((\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)) 
[1]SIMPLIFIER INVOKED ON THE FOLLOWING TERM:
\<not> ((\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)) 
[1]SIMPLIFIER INVOKED ON THE FOLLOWING TERM:
\<not> ((\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)) 
[0]Adding rewrite rule "??.unknown":
ATP.fFalse \<equiv> False                         --- see attempt 2: Undefined fact
[0]Adding rewrite rule "??.unknown":
ATP.fTrue \<equiv> True                           --- see attempt 2: Undefined fact
[0]Adding rewrite rule "??.unknown":
ATP.fNot ?P1 \<equiv> \<not> ?P1 
[0]Adding rewrite rule "??.unknown":
ATP.fconj ?P1 ?Q1 \<equiv> ?P1 \<and> ?Q1 
[0]Adding rewrite rule "??.unknown":
ATP.fdisj ?P1 ?Q1 \<equiv> ?P1 \<or> ?Q1 
[0]Adding rewrite rule "??.unknown":
ATP.fimplies ?P1 ?Q1 \<equiv> ?P1 \<longrightarrow> ?Q1 
[0]Adding rewrite rule "??.unknown":
ATP.fequal ?x1 ?y1 \<equiv> ?x1 = ?y1 
[0]Adding rewrite rule "??.unknown":
ATP.fAll ?P1 \<equiv> All ?P1 
[0]Adding rewrite rule "??.unknown":
ATP.fEx ?P1 \<equiv> Ex ?P1 
[1]SIMPLIFIER INVOKED ON THE FOLLOWING TERM:
\<not> ATP.fTrue \<Longrightarrow> False 
[1]Applying instance of rewrite rule "??.unknown":
ATP.fTrue \<equiv> True 
[1]Rewriting:
ATP.fTrue \<equiv> True 
[0]Adding rewrite rule "??.unknown":
ATP.fFalse \<equiv> False 
[0]Adding rewrite rule "??.unknown":
ATP.fTrue \<equiv> True 
[0]Adding rewrite rule "??.unknown":
ATP.fNot ?P1 \<equiv> \<not> ?P1 
[0]Adding rewrite rule "??.unknown":
ATP.fconj ?P1 ?Q1 \<equiv> ?P1 \<and> ?Q1 
[0]Adding rewrite rule "??.unknown":
ATP.fdisj ?P1 ?Q1 \<equiv> ?P1 \<or> ?Q1 
[0]Adding rewrite rule "??.unknown":
ATP.fimplies ?P1 ?Q1 \<equiv> ?P1 \<longrightarrow> ?Q1 
[0]Adding rewrite rule "??.unknown":
ATP.fequal ?x1 ?y1 \<equiv> ?x1 = ?y1 
[0]Adding rewrite rule "??.unknown":
ATP.fAll ?P1 \<equiv> All ?P1 
[0]Adding rewrite rule "??.unknown":
ATP.fEx ?P1 \<equiv> Ex ?P1 
[1]SIMPLIFIER INVOKED ON THE FOLLOWING TERM:
ATP.fFalse \<Longrightarrow> False 
[1]Applying instance of rewrite rule "??.unknown":
ATP.fFalse \<equiv> False 
[1]Rewriting:
ATP.fFalse \<equiv> False 
[0]Adding rewrite rule "Metis.not_atomize":
(\<not> ?A \<Longrightarrow> False) \<equiv> ?A 
[1]SIMPLIFIER INVOKED ON THE FOLLOWING TERM:
\<not> P x__ y__ \<Longrightarrow> False 
[1]Applying instance of rewrite rule "Metis.not_atomize":
(\<not> ?A \<Longrightarrow> False) \<equiv> ?A 
[1]Rewriting:
(\<not> P x__ y__ \<Longrightarrow> False) \<equiv> P x__ y__ 
[0]Adding rewrite rule "HOL.atomize_not":
(?A \<Longrightarrow> False) \<equiv> \<not> ?A 
[1]SIMPLIFIER INVOKED ON THE FOLLOWING TERM:
P x__ y__*)
thm HOL.simp_implies_def --\<open>(op =simp=> \<equiv> op \<Longrightarrow>)\<close>
thm HOL.Ex1_def          --\<open>{* Ex1 ?P \<equiv> \<exists>x. ?P x \<and> (\<forall>y. ?P y \<longrightarrow> y = x)\<close>
thm HOL.atomize_not      --\<open>{* (?A \<Longrightarrow> False) \<equiv> \<not> ?A\<close>

(* attempt 4 to watch, see David Greenaway http://stackoverflow.com/a/26827242/570879 *)
lemma "(\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)"
apply_trace auto
done
(*used theorems:
    allE: \<forall>x. ?P x \<Longrightarrow> (?P ?x \<Longrightarrow> ?R) \<Longrightarrow> ?R
    allI: (\<And>x. ?P x) \<Longrightarrow> \<forall>x. ?P x
    ccontr: (\<not> ?P \<Longrightarrow> False) \<Longrightarrow> ?P
    exE: \<exists>x. ?P x \<Longrightarrow> (\<And>x. ?P x \<Longrightarrow> ?Q) \<Longrightarrow> ?Q
    exI: ?P ?x \<Longrightarrow> \<exists>x. ?P x
    impI: (?P \<Longrightarrow> ?Q) \<Longrightarrow> ?P \<longrightarrow> ?Q
    swap: \<not> ?P \<Longrightarrow> (\<not> ?R \<Longrightarrow> ?P) \<Longrightarrow> ?R *)

(* attempt 5 to watch, see David Greenaway http://stackoverflow.com/a/26827242/570879 *)
lemma "(\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)"
apply_trace metis
done
(*used theorems:
    ccontr: (\<not> ?P \<Longrightarrow> False) \<Longrightarrow> ?P
    conjunct1: ?P \<and> ?Q \<Longrightarrow> ?P
    conjunct2: ?P \<and> ?Q \<Longrightarrow> ?Q
    exE: \<exists>x. ?P x \<Longrightarrow> (\<And>x. ?P x \<Longrightarrow> ?Q) \<Longrightarrow> ?Q
    notE: \<not> ?P \<Longrightarrow> ?P \<Longrightarrow> ?R
    spec: \<forall>x. ?P x \<Longrightarrow> ?P ?x
    all_forward: \<forall>x. ?P' x \<Longrightarrow> (\<And>x. ?P' x \<Longrightarrow> ?P x) \<Longrightarrow> \<forall>x. ?P x
    Meson.conj_exD1: (\<exists>x. ?P x) \<and> ?Q \<Longrightarrow> \<exists>x. ?P x \<and> ?Q
    Meson.conj_exD2: ?P \<and> (\<exists>x. ?Q x) \<Longrightarrow> \<exists>x. ?P \<and> ?Q x
    conj_forward: ?P' \<and> ?Q' \<Longrightarrow> (?P' \<Longrightarrow> ?P) \<Longrightarrow> (?Q' \<Longrightarrow> ?Q) \<Longrightarrow> ?P \<and> ?Q
    ex_forward: \<exists>x. ?P' x \<Longrightarrow> (\<And>x. ?P' x \<Longrightarrow> ?P x) \<Longrightarrow> \<exists>x. ?P x
    Meson.not_allD: \<not> (\<forall>x. ?P x) \<Longrightarrow> \<exists>x. \<not> ?P x
    Meson.not_exD: \<not> (\<exists>x. ?P x) \<Longrightarrow> \<forall>x. \<not> ?P x
    Meson.not_impD: \<not> (?P \<longrightarrow> ?Q) \<Longrightarrow> ?P \<and> \<not> ?Q
    Metis.not_atomize: (\<not> ?A \<Longrightarrow> False) \<equiv> ?A*)

section \<open>Handle "arbitrary but fixed"\<close>
(*isar-ref p.11*)
thm nat.induct
(*?P 0 \<Longrightarrow> (\<And>nat. ?P nat \<Longrightarrow> ?P (Suc nat)) \<Longrightarrow> ?P ?nat*)
print_statement nat.induct
(*theorem induct:
  fixes P :: "nat \<Rightarrow> bool" 
    and nat :: "nat" 
  assumes "P 0"
    and "\<And>nat. P nat \<Longrightarrow> P (Suc nat)"
  shows "P nat" *)

thm impE   --{* ?P \<longrightarrow> ?Q \<Longrightarrow> ?P \<Longrightarrow> (?Q \<Longrightarrow> ?R) \<Longrightarrow> ?R *}
thm rev_mp --{* ?P \<Longrightarrow> ?P \<longrightarrow> ?Q \<Longrightarrow> ?Q *}

thm exI --{* ?P ?x \<Longrightarrow> \<exists>x. ?P x *}
thm exE --{* \<exists>x. ?P x \<Longrightarrow> (\<And>x. ?P x \<Longrightarrow> ?Q) \<Longrightarrow> ?Q *}

(*"arbitrary but fixed" prog-prove.pdf p.6*)
term "\<And>x. x = x"

(*"arbitrary but fixed" isar-ref.pdf p.26*
declare[[show_types]]

notepad
begin
  have "x \<in> \<Inter>\<A>"
  proof
    fix A
    assume "A \<in> \<A>"
  (*show "x \<in> \<A>"     with \<subseteq> also not type correct *)
  oops
end 
WE HAVE AT FINAL "end" BELOW:
Illegal application of command "end"\<here> at top level, result theory "Examples"*)

section \<open>Be careful with operator precedence\<close>
declare[[show_brackets]]
term " \<exists>x. \<forall>y. P x y  \<longrightarrow> (\<forall>y. \<exists>x. P x y)" --{*"(\<exists>x. (\<forall>y. ((P x y) \<longrightarrow> (\<forall>y. (\<exists>x. (P x y))))))"*}
term "(\<exists>x. \<forall>y. P x y) \<longrightarrow> (\<forall>y. \<exists>x. P x y)" --{*"((\<exists>x. (\<forall>y. (P x y))) \<longrightarrow> (\<forall>y. (\<exists>x. (P x y))))"*}

text \<open>\<close>
text \<open>\<close>

section \<open>apply rule\<close>
(*"apply (rule ...)" tutorial p.68*)
lemma conj_rule: "\<lbrakk>P; Q\<rbrakk> \<Longrightarrow> P \<and> (Q \<and> P)"
apply (rule conjI)
apply assumption
apply (rule conjI)
apply assumption
apply assumption
oops

section \<open>xxx\<close>

end
