theory Isa_For_Math_2 imports Main Fact Groups begin

section {* Examples for induction following a thread in isabelle@ *}

text {* In the thread beginning with
  https://lists.cam.ac.uk/mailman/htdig/cl-isabelle-users/2015-March/msg00191.html
  an academic teacher asks for advice on his teaching to prove induction.
*}

term "fact"
term "n :: nat"
term "fact (n :: nat)"
term "(fact n :: nat)"
term "a-1"
term "a- 1"

lemma ind_from_2[case_names 0 1 2 many]:
  assumes "P 0"
  assumes "P 1"
  assumes "P 2"
  assumes "\<forall> k. k \<ge> 2 \<and> P k \<longrightarrow> P (Suc k)"
  shows "P n"
proof (induction n)
  case 0 thus ?case by fact
next
  case (Suc k)
  have "k = 0 \<or> k = 1 \<or> k \<ge> 2" by auto
  with Suc.IH assms   
  show ?case by (auto simp add: numeral_eq_Suc)
qed           

lemma fact2: "fact (2::nat) = 2"
(* apply (rule fact_plus_one_nat) LERNSITUATION: IN Fact SIND NUR WENIGE THEOREME 1 ! 1*)
oops 
lemma "(fact n :: nat) \<le> 2^(n - 1)"
proof(induction n rule: ind_from_2)
  case 0 show ?case by auto
next
  case 1 show ?case by auto
next
  case 2 show ?case by simp (add: arith)
next
  case many show ?case by auto
qed

thm fact_1_nat
term "3::nat"

ML {*
  @{term 4};
*} ML {*
  @{term "(4::nat)"};
*} ML {*
  @{term "(4::nat)"};
*} ML {*
  @{term "(1::nat)"};
*}

lemma "(fact n :: nat) \<le> 2^(n - 1)"
proof (induct n)
  case 0
  thus ?case by auto
next
  case (Suc n) note IH = this
  { assume "Suc n = 1"
     hence ?case by auto    
  }
  also {
    assume "Suc n > 1"
    have ?case sorry
  }
  ultimately show ?case by arith
qed

lemma "0 \<le> x \<Longrightarrow> 0 \<le> y \<Longrightarrow> x + y = 0 \<longleftrightarrow> x = 0 \<and> y = 0"
by (simp add: add_nonneg_eq_0_iff)

lemma add_nonneg_eq_0_iff:
  assumes x: "0 \<le> x" and y: "0 \<le> y"
  shows "x + y = 0 \<longleftrightarrow> x = 0 \<and> y = 0"
proof (intro iffI conjI)
  have "x = x + 0" by simp
  also have "x + 0 \<le> x + y" using y by (rule add_left_mono)
  also assume "x + y = 0"
  also have "0 \<le> x" using x .
  finally show "x = 0" .
next
  have "y = 0 + y" by simp
  also have "0 + y \<le> x + y" using x by (rule add_right_mono)
  also assume "x + y = 0"
  also have "0 \<le> y" using y .
  finally show "y = 0" .
next
  assume "x = 0 \<and> y = 0"
  then show "x + y = 0" by simp
qed


end



